#! /bin/sh
#
# Automatic alias generator.
#
# Copyright (C) 2005-2006  NTT DATA CORPORATION
#
# Version: 1.2   2006/09/03
#
# Run this script and add the output to /root/security/exception_policy.txt .
# You MUST review the content of /root/security/exception_policy.txt
# because there would be redundant or dangerous entries.
#

# Ignore files on nodev filesystem.
for FS in `awk ' { if ( NF == 1) print $1; } END { print "rootfs"; } ' /proc/filesystems`
  do
  for SYMLINK in `find / -type l -fstype $FS`
	do

	# Solve symbolic name.
	ENTITY=`readlink -fn $SYMLINK`

	# Reject if it is not a regular file.
	[ -f "$ENTITY" -a -x "$ENTITY" ] || continue

	# Reject if basename is the same. 
	F1=`basename $ENTITY`
	F2=`basename $SYMLINK`
	[ $F1 = $F2 ] && continue

	# Reject if file is not executable. 
	file $ENTITY | grep -q executable || continue

	# Exclude /etc/rc?.d/ directory.
	echo $F2 | grep -q '^[SK][0-9][0-9]' && continue

	# This is a candidate.
	echo 'alias '$ENTITY' '$SYMLINK

  done
done | sort | uniq
